def top_nav(context, _memo={}):
    """ Generate top nav.
    """
    if not _memo.has_key('nav_info'):
        root = context.root()
        nav_pages = []
        pages = [root]
        while pages:
            page = pages.pop()
            pages.extend([page.get(c) for c in page.dirnames])
            if 'nav_text' in page.filenames:
                nav_pages.append(page)
        nav_info = []
        for page in nav_pages:
            nav_path = page.base_path()
            order = unicode(page['nav_order']).strip()
            text = unicode(page['nav_text'])
            nav_info.append((order, nav_path, text))
        nav_info.sort()
        nav_info.reverse()
        _memo['nav_info'] = nav_info

    return [_NavLink((p,h), context) for (o,p,h) in _memo['nav_info']]

class _NavLink(object):
    """ Used for generating top nav.
    """
    sections = {}
    def __init__(self, (path, name), context):
        self.name = name
        if not path.count('/'): path = '/'
        self.path = path
        self.context = context
        if not self.sections.has_key(path):
            self.sections[path] = context.root().get(path[1:], context.root())

    def active(self):
        """ Pick up whether this nav link should be marked as active or not.
        """
        if self.path == '/':
            if not self.context.dirpath.count('/'):
                return ' id="active"'
        elif self.context.dirpath.count(self.path[:-1]):
            return ' id="active"'
        return ''

    def title(self):
        return self.sections[self.path].title()



