""" Decorators for setting the plugin types.

Simply add your functions to the appropriate data structure.
Hooks are run in list order.

plugin          - functions inserted into template rendering namespace
                - function parameters: page

pre_site_hook   - functions called before any rendering has occured
                - function parameters: page_tree, plugin_object

pre_page_hook   - functions called before each page rendering
                - function parameters: page, plugin_object

post_page_hook  - functions called after each page rendering
                - function parameters: page, plugin_object

post_site_hook  - functions called after all page rendering has occured
                - function parameters: page_tree, plugin_object
"""

def plugin(func):
    func.plugin_type = 'plugin'
    return func

def pre_site_hook(func):
    func.plugin_type = 'pre_site_hook'
    return func

def post_page_hook(func):
    func.plugin_type = 'post_page_hook'
    return func

def pre_page_hook(func):
    func.plugin_type = 'pre_page_hook'
    return func

def post_site_hook(func):
    func.plugin_type = 'post_site_hook'
    return func

